/* ****************************************************************************
	adtek_8132 device driver check program	check_02.c
	2001/04/27	by M.tadano
	usage	:	check8132 
******************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/time.h>
#include	<signal.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/ioctl.h>

#define		MAX_PORT	8

/* ***************************************************************************/
int main (int argc, char **argv)
{
char	buf[MAX_PORT];
int	maxfd, fd, ret, i;
static fd_set	mask;
static struct timeval	timeout;

	printf ("program start\n");

	if ((fd = open ("/dev/adtek_8132", O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}
	maxfd = fd + 1;
	while(1)	{
		timeout.tv_sec = 10;
		timeout.tv_usec = 0;
		FD_ZERO (&mask);
		FD_SET (0, &mask);
		FD_SET (fd, &mask);
		ret = select (maxfd, &mask, (fd_set *)0, (fd_set *)0, &timeout);
		if (ret == 0)	{
			printf ("Timeout device read(ret=%d) ", ret);
			ret = read (fd, buf, MAX_PORT);
			if ( ret == 0)	{
				for (i = 0; i < MAX_PORT; i++)	{
					printf ("port[%d]= %2x ",
						i+1, buf[i]);
				}
				printf ("\n");
			}
		} else if (FD_ISSET (fd, &mask))	{
			printf ("Interrupts data(ret=%d) ", ret);
			ret = read (fd, buf, MAX_PORT);
			if ( ret == 0)	{
				for (i = 0; i < MAX_PORT; i++)	{
					printf ("port[%d]= %2x ",
						i+1, buf[i]);
				}
				printf ("\n");
			}
		} else	{
			printf ("sleep/");
			sleep (1);
		}
	}
	close (fd);
	printf ("program end\n");
}
/* end of file ***************************************************************/
