/* 
	evaluate program for adtek 8133		measure_8133_02.c
	2001/05/18
*/

#include	<stdio.h>
#include	<sys//types.h>
#include	<sys/errno.h>
#include	<sys/time.h>
#include	<unistd.h>
#include	<fcntl.h>

#include	"../adtek_8133_O.h"

#define	DEVICE	"/dev/adtek_8133"
#define	LOOP	1000

typedef struct	{
	unsigned char	data;
	int	port;
} set_up_t;

/******************************************************************************/
int main (int argc, char **argv)
{
int     min_max (int loop, int *e_time, int overhead, int *min, int *max);
int	i;
struct timeval	timevalue0[LOOP], timevalue1[LOOP];
set_up_t	setup;
int	elapsed[LOOP];
int	average = 0, min =9999, max = 0;
int	overhead = 0;
time_t	now_time;
int	fd, ret = 0;
char	buf[8];

	printf ("Adtek 8133 evaluate program start\n");
	
	setup.data = 0x1;
	setup.port = 1;

	if ((fd = open (DEVICE, O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}

	for (i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		write (fd, (char *)&setup, sizeof (setup));
		get_time (&timevalue1[i]);
		if (ret != 0)	{
			printf ("write error !!!!!\n");
			exit;
		}
	}
	for (i =0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Adtek 8133 Output takes %4d microsecond.\n", average);
	printf ("                minimum %4d microsecond.\n", min);
	printf ("                maximum %4d microsecond.\n", max);
	printf ("overhead %d microsecond.\n", overhead);

	close (fd);
	printf ("program end\n");
	exit (0);
}
/*****************************************************************************/
int     min_max (int loop, int *e_time, int overhead, int *min, int *max)
{
int     i, average;

        average = 0;
        for (i = 0; i < loop; i++)      {
                if (*(e_time+i) < *min) {
                        *min = *(e_time+i) - overhead;
                        printf ("i=%d min=%d max=%d\n", i, *min, *max);
                }
                if (*max < *(e_time+i)) {
                        *max = *(e_time +i) - overhead;
                        printf ("i=%d min=%d max=%d\n", i, *min, *max);
                }
                average += *(e_time+i) - overhead;
        }
	average /= loop;
        return average;
}
/*****************************************************************************/
get_time (timevalue)
struct timeval	*timevalue;
{
struct timezone	tzp;

	gettimeofday (timevalue, &tzp);
}
/*****************************************************************************/
int	e_time (first, second)
struct timeval	*first, *second;
{

	if (first->tv_usec > second->tv_usec)	{
		second->tv_usec += 1000000;
		second->tv_sec--;
	}
	return ((int)(second->tv_sec - first->tv_sec)*1000000
		+ (int)(second->tv_usec - first->tv_usec));
}
/* end of file **************************************************************/
