/* 
	evaluate program for advanet 2610
	2001/04/16
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys//types.h>
#include	<sys/errno.h>
#include	<sys/time.h>
#include	<unistd.h>
#include	<fcntl.h>

#include	"../advanet_2610_AD.h"

#define	LOOP	1000

/**********************************************************************/
int main (int argc, char **argv)
{
int	min_max (int loop, int *e_time, int overhead, int *min, int *max);
int	i;
struct timeval	timevalue0[LOOP], timevalue1[LOOP];
int	elapsed[LOOP], average = 0, overhead = 0, min = 10000, max = 0;
time_t	now_time;
int	fd, len, j, data;
set_up_t	setup;
short		mode = 0, *read_buf;
int		count = 0;
long int	interval = 0;

	printf ("program start\n");
	mode = SINGLE_MULTICHN;
	count = 1;
	interval = 1000;	/* set at 1[msec] */

	read_buf = (short *)malloc(sizeof(unsigned short)*count*CHANNEL_MAX);
	if (read_buf == NULL)	{
		perror ("malloc error:");
		return -1;
	}
	if ((fd = open ("/dev/advanet_2610", O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}

	setup.mode = mode;
	setup.count = count;
	setup.interval = interval;		/* unit [msec] */
	printf ("mode = %d count %d interval = %d\n", mode, count, interval);

	for (i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	overhead /= LOOP;

	count = setup.count;
	for (i = 0; i < LOOP; i++)	{
		if (write (fd, (char *)&setup, sizeof (setup)) != 0)	{
			printf ("write error !!!!!\n");
			exit;
		}
		get_time (&timevalue0[i]);
		len = read (fd, read_buf, count);
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
	average = min_max (LOOP, &elapsed[0], overhead, &min, &max);
	printf ("Advanet 2610 ADC single read average takes %d microsecond.\n",
								average);
	printf ("                                   minimum %d microsecond.\n", 
								min);
	printf ("                                   maximum %d microsecond.\n", 
								max);
	printf ("overhead %d microsecond.\n", overhead);

	close (fd);
	printf ("program end\n");
	exit (0);
}
/*****************************************************************************/
int	min_max (int loop, int *e_time, int overhead, int *min, int *max)
{
int	i, average;

	average = 0;
	for (i = 0; i < loop; i++)	{
		if (*(e_time+i) < *min)	{
			*min = *(e_time+i);
			printf ("i=%d min=%d max=%d\n", i, *min, *max);
		}
		if (*max < *(e_time+i))	{
			*max = *(e_time +i);
			printf ("i=%d min=%d max=%d\n", i, *min, *max);
		}
		average += *(e_time+i) - overhead;
	}
	average /= loop;
	return average;
}
/* ***************************************************************************/
get_time (struct timeval *timevalue)
{
struct timezone	tzp;

	gettimeofday (timevalue, &tzp);
}

/* ***************************************************************************/
int	e_time (first, second)
struct timeval	*first, *second;
{

	if (first->tv_usec > second->tv_usec)	{
		second->tv_usec += 1000000;
		second->tv_sec--;
	}
	return ((int)(second->tv_sec - first->tv_sec)*1000000
		+ (int)(second->tv_usec - first->tv_usec));
}
/* end of file ***************************************************************/
