/******************************************************************************
	advanet_2610 ADC read & data save test program	read_ADC_2610_01.c
	2001/03/0*	by M.tadano
	usage	:	read_2610 1 1000 100	
			read_2610 'mode' 'interval' 'max_count'
******************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/stat.h>
#include	<sys/ioctl.h>

#include	"advanet_2610_AD.h"
#define		DEVICE	"/dev/advanet_2610"


int main (int argc, char **argv)
{
FILE	*write_fd;
time_t	now_time;
int	fd, len, i, j, data;
unsigned long	loopcount;
set_up_t	setup;
short		mode = 0, *read_buf;
int		count = 0, count2 = 0;
long int	interval = 0;

	printf ("program start\n");
	if (1 < argc )
		mode = atoi (argv[1]);
	if (mode == 0)	{
		printf ("sampring mode 1:single 2:mutiple 3:continue ? ");
		scanf ("%d", (int *)&mode);
	}
	switch (mode)	{
	case 1:
		mode = SINGLE_MULTICHN;
		count = 1;
		break;
	case 2:
		mode = MULTI_MULTICHN;
		break;
	case 3:
		mode = CONTINUAS_MULTICHN;
		count = 1;
		break;
	default:
		mode = SINGLE_MULTICHN;
		count = 1;
		break;
	}
	if (2 < argc)
		interval = atoi (argv[2]);
	if ((interval == 0) &&
			(mode == MULTI_MULTICHN || mode == CONTINUAS_MULTICHN))	{
		printf ("sampring interval [unit:usec] ? ");
		scanf ("%d", (int *)&interval);
	}
	if (interval == 0)
		interval = 1000;	/* set at 1[msec] */

	if (3 < argc )
		count = atoi (argv[3]);
	if (count == 0)	{
		printf ("sampring number ? ");
		scanf ("%d", &count);
	}
	read_buf = (short *)malloc(sizeof(unsigned short)*count*CHANNEL_MAX);
	if (read_buf == NULL)	{
		perror ("malloc error:");
		return -1;
	}
	printf ("get memory size %d\n",
			sizeof (unsigned short)*count*CHANNEL_MAX);
	if ((write_fd = fopen ("testsavedata", "w")) == NULL)	{
		printf ("file open error.\n");
		exit (1);
	}
	if ((fd = open (DEVICE, O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}

	setup.mode = mode;
	setup.count = count;
	setup.interval = interval;		/* unit [msec] */
	printf ("mode = %d count %d interval = %d\n", mode, count, interval);
	printf ("device file write\n");
	if (write (fd, (char *)&setup, sizeof (setup)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}

	loopcount = 0;
	count = setup.count * CHANNEL_MAX;
	printf ("device file read\n");
	do	{
		len = read (fd, read_buf, count*2);
		if (len == 0)	{
			printf (" len=0 ");
			continue;
		}
		count2 += len;
		printf ("\t\t\t\t\t  Hex  Raw   Conv.\n");
		for (i = 0; i < setup.count; i++)	{
			if ((mode == CONTINUAS_MULTICHN) ||
					(mode == CONTINUAS_SINGLECHN))
				loopcount++;
			time (&now_time);
			fprintf (write_fd, "%.24s ",
					asctime (localtime (&now_time)));
			for (j = 0; j < CHANNEL_MAX; j++)	{
				data = *(read_buf+i*CHANNEL_MAX+j) & 0xffff;
				printf ("loopcount:%4d  address:%4x ",
					i+loopcount*setup.count,
					(read_buf+i*CHANNEL_MAX+j));
				printf ("chn = %2d data:%4x %5d %f\n",
					j, data, data,
					10.24*(data-0x8000)/32768.0);
				fprintf (write_fd, "  %f",
					10.24*(data-0x8000)/32768.0);
			}
			fprintf (write_fd, "\n");
			fflush (write_fd);
		}
		if (count2 < setup.count)	{
			printf ("count2 = %d < setup.count = %d\n",
				count2, setup.count);
/*			continue;
*/
		}
	} while ((mode == CONTINUAS_MULTICHN) || (mode == CONTINUAS_SINGLECHN));

	close (fd);
	printf ("program end\n");
	exit (0);
}
/* end of file ***************************************************************/
