/* 
	precison.c
	2001/04/13
*/

#include	<time.h>
#include	<sys/time.h>
#include	<unistd.h>
#include	<stdio.h>

void	get_time (struct timeval *timevalue)
{
struct timezone	tzp;

	gettimeofday (timevalue, &tzp);

}

int	e_time (struct timeval *first, struct timeval *second)
{
	if (first->tv_usec > second->tv_usec)	{
		second->tv_usec += 1000000;
		second->tv_sec--;
	}

#ifdef	DEBUG
	printf ("elapsed time %d sec, %d microsec\n", 
		second->tv_sec - first->tv_sec, 
		second->tv_usec -first->tv_usec);
#endif
	return ((int)(second->tv_sec - first->tv_sec)*1000000
		+ (int)(second->tv_usec - first->tv_usec));
}

int main (int argc, char **argv)
{
struct timeval	start, stop;
struct timespec	req, rem;
int	sleeptime;

	if (argc < 2)	sleeptime = 1000;
	else sleeptime = atol (argv[1]);
	get_time (&start);
	usleep ((unsigned long)sleeptime);
	get_time (&stop);
	printf ("elapsed time for usleep(%d) = %d in microsec.\n",
		sleeptime, e_time (&start, &stop));
	
	req.tv_sec = sleeptime / 1000000;
	req.tv_nsec = (sleeptime % 1000000) * 1000;
	get_time (&start);
	nanosleep (&req, &rem);
	get_time (&stop);
	printf ("elapsed time for nanosleep(%d) = %d in microsec.\n",
		sleeptime*1000, e_time (&start, &stop));
}
