/* 
	rmstest.c
	2001.04.13
*/

#include	<unistd.h>
#include	<math.h>

double	mean (double *data, int count, double *min, double *max);
double	rms (double *data, int count);

double	mean (double *data, int count, double *min, double *max)
{
double	average = 0;
int	i;

	*min = data[0];
	*max = data[0];

	for (i=0; i < count; i++)	{
		average += data[i];
		if (*min > data[i]) *min = data[i];
		if (*max < data[i]) *max = data[i];
	}
	average /= (double)count;
	return average;
}

double	rms (double *data, int count)
{
double	average, variance, min, max;
double	sum = 0;
int	i;

	average = mean (data, count, &min, &max);
	printf ("average, min, and max. = %f, %f and %f\n",
		average, min, max);
	for (i = 0; i < count; i++)	{
		variance = data[i];
		variance -= average;
		sum += variance * variance;
	}
	sum /= (double)count;
	sum = sqrt (sum);
	return (sum);
}

void	measure (void);
void	measure (void)
{
int	i;

	for ( i = 0; i < 10000; i++);

}

void	result (double *data_time, int loop);
void	result (double *data_time, int loop)
{

	printf ("RMS of measured data is %f.\n", 
		rms (data_time, loop));
}

main ()
{
unsigned long long	start;
int	i, j, loop;
double	root_mean_square, data_time[10000];

	loop = 100;

	for (i = 0; i < loop; i++)	{
		start = microsecond ();
		measure ();
		data_time[i] = (double)(microsecond() - start);
	}
	
	result (data_time, loop);
}
